/*
*       Copyright (c) 2011-2019 by esd electronics gmbh
*
*  This software is copyrighted by and is the sole property of
*  esd gmbh.  All rights, title, ownership, or other interests
*  in the software remain the property of esd gmbh. This
*  software may only be used in accordance with the corresponding
*  license agreement.  Any unauthorized use, duplication, transmission,
*  distribution, or disclosure of this software is expressly forbidden.
*
*  This Copyright notice may not be removed or modified without prior
*  written consent of esd gmbh.
*
*  esd gmbh, reserves the right to modify this software without notice.
*
*  esd electronics gmbh                   Tel. +49-511-37298-0
*  Vahrenwalder Strasse 207               Fax. +49-511-37298-68
*  30165 Hannover                         http://www.esd.eu
*  Germany                                sales@esd.eu
*
*************************************************************************
*
* Description:
* =============================================================================
* This file describes the interface to the ess HAL.
* NOT needed by application.
*
*/

#ifndef ESS_HAL_INCLUDED
#define ESS_HAL_INCLUDED

#include "../include/essTypes.h"

#ifdef __cplusplus
extern "C" {
#endif

HAL_EXPORT ESS_RESULT           HAL_CALLTYPE essHALOpen(ESS_DEVICE_INDEX devIdx);

HAL_EXPORT ESS_RESULT           HAL_CALLTYPE essHALClose(ESS_DEVICE_INDEX devIdx);

HAL_EXPORT ESS_TIMESTAMP        HAL_CALLTYPE essHALGetTime(void);

HAL_EXPORT ESS_RESULT           HAL_CALLTYPE essHALGetSystemTime(ESS_DEVICE_INDEX devIdx, ESS_SYSTIME *sysTime);

HAL_EXPORT ESS_RESULT           HAL_CALLTYPE essHALMapESC(ESS_DEVICE_INDEX devIdx, void** escPointer);

HAL_EXPORT ESS_RESULT           HAL_CALLTYPE essHALUnmapESC(ESS_DEVICE_INDEX devIdx);

HAL_EXPORT ESS_RESULT           HAL_CALLTYPE essHALStart(ESS_DEVICE_INDEX devIdx, ESS_HAL_CALLBACK* isr, ESS_HAL_CALLBACK* cyclicCallback, uint32_t cyclicInterval, void* cbData);

HAL_EXPORT ESS_RESULT           HAL_CALLTYPE essHALStop(ESS_DEVICE_INDEX devIdx);

HAL_EXPORT void                 HAL_CALLTYPE essHALReadESCMem(ESS_DEVICE_INDEX devIdx, uint16_t address, void* dst, uint16_t len);

HAL_EXPORT void                 HAL_CALLTYPE essHALWriteESCMem(ESS_DEVICE_INDEX devIdx, uint16_t address, const void* src, uint16_t len);

HAL_EXPORT ESS_RESULT           HAL_CALLTYPE essHALSetLEDState(ESS_DEVICE_INDEX devIdx, ESC_LED_TYPE ledId, ESS_BOOL ledOn);

HAL_EXPORT void                 HAL_CALLTYPE essHALStackEvent(ESS_EVENT_DATA* e);

HAL_EXPORT ESS_RESULT           HAL_CALLTYPE essHALIoctl(ESS_DEVICE_INDEX devIdx, ESS_IOCTL fn, void* data, uint32_t sizeOfData);

extern ESS_HAL_CALLBACK         Sync0_Event;

extern ESS_HAL_CALLBACK         Sync1_Event;

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* ESS_HAL_INCLUDED */
