/*
*       Copyright (c) 2011 - 2020 by esd electronics gmbh
*
*  This software is copyrighted by and is the sole property of
*  esd gmbh.  All rights, title, ownership, or other interests
*  in the software remain the property of esd gmbh. This
*  software may only be used in accordance with the corresponding
*  license agreement.  Any unauthorized use, duplication, transmission,
*  distribution, or disclosure of this software is expressly forbidden.
*
*  This Copyright notice may not be removed or modified without prior
*  written consent of esd gmbh.
*
*  esd gmbh, reserves the right to modify this software without notice.
*
*  esd electronics gmbh                   Tel. +49-511-37298-0
*  Vahrenwalder Str 207                   Fax. +49-511-37298-68
*  30165 Hannover                         http://www.esd.eu
*  Germany                                sales@esd.eu
*
*************************************************************************
*
* Description:
* =============================================================================
* This file contains the "EtherCAT defines": register addresses, etc.
* (Not used by HAL)
*
*/


#ifndef ECATDEFS_INCLUDED
#define ECATDEFS_INCLUDED

#define ESC_REG_TYPE                                    ((uint16_t)0x0000)
#define ESC_REG_REVISION                                ((uint16_t)0x0001)
#define ESC_REG_BUILD                                   ((uint16_t)0x0002)
#define ESC_REG_SMCOUNT                                 ((uint16_t)0x0005)
#define ESC_REG_FEATURES                                ((uint16_t)0x0008)
#define ESC_REG_STATIONADDRESS                          ((uint16_t)0x0010)
#define ESC_REG_STATIONALIAS                            ((uint16_t)0x0012)
#define ESC_REG_DLSTATUS                                ((uint16_t)0x0110)
#define ESC_REG_ALCONTROL                               ((uint16_t)0x0120)
/* Hint: ESC_REG_ALSTATUSCODE should be written before ESC_REG_ALSTATUS */
#define ESC_REG_ALSTATUS                                ((uint16_t)0x0130)
#define ESC_REG_ALSTATUSCODE                            ((uint16_t)0x0134)
#define ESC_REG_PDICONTROL                              ((uint16_t)0x0140)
#define ESC_REG_PDICONFIGURATION                        ((uint16_t)0x0150)
#define ESC_REG_ALEVENTMASK                             ((uint16_t)0x0204)
#define ESC_REG_ECATEVENTREQ                            ((uint16_t)0x0210)
#define ESC_REG_ALEVENTREQ                              ((uint16_t)0x0220)
#define ESC_REG_WATCHDOG_DIVIDER                        ((uint16_t)0x0400)
#define ESC_REG_WATCHDOG_TIMEPDI                        ((uint16_t)0x0410)
#define ESC_REG_WATCHDOG_TIMEPROCESSDATA                ((uint16_t)0x0420)
#define ESC_REG_WATCHDOG_STATUSPROCESSDATA              ((uint16_t)0x0440)
#define ESC_REG_WATCHDOG_COUNTERPROCESSDATA             ((uint16_t)0x0442)
#define ESC_REG_WATCHDOG_COUNTERPDI                     ((uint16_t)0x0443)
#define ESC_REG_EEPROMCONFIGURATION                     ((uint16_t)0x0500)
#define ESC_REG_EEPROMPDIACCESSSTATE                    ((uint16_t)0x0501)
#define ESC_REG_EEPROMCTRLSTATUS                        ((uint16_t)0x0502)
#define ESC_REG_EEPROMADDRESS                           ((uint16_t)0x0504)
#define ESC_REG_EEPROMDATA                              ((uint16_t)0x0508)
#define ESC_REG_EEPROMDATAHI                            ((uint16_t)0x050c)
#define ESC_REG_MII_CTRLSTAT                            ((uint16_t)0x0510)
#define ESC_REG_PHY_ADDR                                ((uint16_t)0x0512)
#define ESC_REG_PHY_REGADDR                             ((uint16_t)0x0513)
#define ESC_REG_PHY_REGDATA                             ((uint16_t)0x0514)
#define ESC_REG_MII_ECATACCESS                          ((uint16_t)0x0516)
#define ESC_REG_MII_PDIACCESS                           ((uint16_t)0x0517)
#define ESC_REG_PHY_PORT0_STATUS                        ((uint16_t)0x0518)
#define ESC_REG_PHY_PORT1_STATUS                        ((uint16_t)0x0519)
#define ESC_REG_PHY_PORT2_STATUS                        ((uint16_t)0x051a)
#define ESC_REG_PHY_PORT3_STATUS                        ((uint16_t)0x051b)
#define ESC_REG_DCSYSTEMTIME                            ((uint16_t)0x0910)
#define ESC_REG_DCSYSTEMTIMEHI                          ((uint16_t)0x0914)
#define ESC_REG_DCSYSTEMTIMEOFFSET                      ((uint16_t)0x0920)
#define ESC_REG_DCUNITCONTROL                           ((uint16_t)0x0980)
#define ESC_REG_DCSYNCACTIVATION                        ((uint16_t)0x0981)
#define ESC_REG_SYNCPULSELEN                            ((uint16_t)0x0982)
#define ESC_REG_SYNC0STATUS                             ((uint16_t)0x098e)
#define ESC_REG_SYNC1STATUS                             ((uint16_t)0x098f)
#define ESC_REG_DCSTARTTIME                             ((uint16_t)0x0990)
#define ESC_REG_SYNC0NEXT                               ((uint16_t)0x0990)
#define ESC_REG_SYNC1NEXT                               ((uint16_t)0x0998)
#define ESC_REG_SYNC0INTERVAL                           ((uint16_t)0x09a0)
#define ESC_REG_SYNC1INTERVAL                           ((uint16_t)0x09a4)
#define ESC_REG_LATCH0CONTROL                           ((uint16_t)0x09a8)
#define ESC_REG_LATCH1CONTROL                           ((uint16_t)0x09a9)
#define ESC_REG_LATCH0POS                               ((uint16_t)0x09b0)
#define ESC_REG_LATCH0NEG                               ((uint16_t)0x09b8)
#define ESC_REG_LATCH1POS                               ((uint16_t)0x09c0)
#define ESC_REG_LATCH1NEG                               ((uint16_t)0x09c8)
#define ESC_REG_PONVALUES_ET1XXX                        ((uint16_t)0x0e00)
#define ESC_REG_IPCORE_PRODID                           ((uint16_t)0x0e00)
#define ESC_REG_IPCORE_VENDORID                         ((uint16_t)0x0e08)

#define ESC_REG_SMPHYSADDR(smIdx)                       (((uint16_t)0x0800) + (uint16_t)((smIdx) * 8))
#define ESC_REG_SMLEN(smIdx)                            (((uint16_t)0x0802) + (uint16_t)((smIdx) * 8))
#define ESC_REG_SMCONTROL(smIdx)                        (((uint16_t)0x0804) + (uint16_t)((smIdx) * 8))
#define ESC_REG_SMSTATUS(smIdx)                         (((uint16_t)0x0805) + (uint16_t)((smIdx) * 8))
#define ESC_REG_SMACTIVATE(smIdx)                       (((uint16_t)0x0806) + (uint16_t)((smIdx) * 8))
#define ESC_REG_SMPDICONTROL(smIdx)                     (((uint16_t)0x0807) + (uint16_t)((smIdx) * 8))
#define ESC_REG_FMMUSTARTADDR(fmmuIdx)                  (((uint16_t)0x0600) + (uint16_t)((fmmuIdx) * 16))
#define ESC_REG_FMMULEN(fmmuIdx)                        (((uint16_t)0x0604) + (uint16_t)((fmmuIdx) * 16))
#define ESC_REG_FMMULOGSTARTBIT(fmmuIdx)                (((uint16_t)0x0606) + (uint16_t)((fmmuIdx) * 16))
#define ESC_REG_FMMULOGSTOPBIT(fmmuIdx)                 (((uint16_t)0x0607) + (uint16_t)((fmmuIdx) * 16))
#define ESC_REG_FMMUPHYSSTARTADDR(fmmuIdx)              (((uint16_t)0x0608) + (uint16_t)((fmmuIdx) * 16))
#define ESC_REG_FMMUPHYSSTARTBIT(fmmuIdx)               (((uint16_t)0x060a) + (uint16_t)((fmmuIdx) * 16))
#define ESC_REG_FMMUTYPE(fmmuIdx)                       (((uint16_t)0x060b) + (uint16_t)((fmmuIdx) * 16))
#define ESC_REG_FMMUACTIVATE(fmmuIdx)                   (((uint16_t)0x060c) + (uint16_t)((fmmuIdx) * 16))
#define ESC_REG_USERRAM                                 ((uint16_t)0x0f80)

typedef uint8_t ESC_STATE;
#define ESC_STATE_INIT                                  ((ESC_STATE)0x01)
#define ESC_STATE_PREOP                                 ((ESC_STATE)0x02)
#define ESC_STATE_BOOT                                  ((ESC_STATE)0x03)
#define ESC_STATE_SAFEOP                                ((ESC_STATE)0x04)
#define ESC_STATE_OP                                    ((ESC_STATE)0x08)
#define ESC_STATE_TO_STRING(st)                         (((st) == ESC_STATE_INIT) ? "Init" : ((st) == ESC_STATE_PREOP) ? "PreOp" : ((st) == ESC_STATE_BOOT) ? "Bootstrap" : ((st) == ESC_STATE_SAFEOP) ? "SafeOp" : ((st) == ESC_STATE_OP) ? "Op" : "Unknown")
#define ESC_STATE_KNOWN(st)                             (((st) == ESC_STATE_INIT) || ((st) == ESC_STATE_PREOP) || ((st) == ESC_STATE_BOOT) || ((st) == ESC_STATE_SAFEOP) || ((st) == ESC_STATE_OP))

typedef uint16_t ESC_TRANSITION;
#define ESC_TRANSITION_BI                               ((ESC_TRANSITION)MAKE_WORD(ESC_STATE_BOOT, ESC_STATE_INIT))
#define ESC_TRANSITION_IB                               ((ESC_TRANSITION)MAKE_WORD(ESC_STATE_INIT, ESC_STATE_BOOT))
#define ESC_TRANSITION_BB                               ((ESC_TRANSITION)MAKE_WORD(ESC_STATE_BOOT, ESC_STATE_BOOT))
#define ESC_TRANSITION_II                               ((ESC_TRANSITION)MAKE_WORD(ESC_STATE_INIT, ESC_STATE_INIT))
#define ESC_TRANSITION_IP                               ((ESC_TRANSITION)MAKE_WORD(ESC_STATE_INIT, ESC_STATE_PREOP))
#define ESC_TRANSITION_OI                               ((ESC_TRANSITION)MAKE_WORD(ESC_STATE_OP, ESC_STATE_INIT))
#define ESC_TRANSITION_OP                               ((ESC_TRANSITION)MAKE_WORD(ESC_STATE_OP, ESC_STATE_PREOP))
#define ESC_TRANSITION_OS                               ((ESC_TRANSITION)MAKE_WORD(ESC_STATE_OP, ESC_STATE_SAFEOP))
#define ESC_TRANSITION_OO                               ((ESC_TRANSITION)MAKE_WORD(ESC_STATE_OP, ESC_STATE_OP))
#define ESC_TRANSITION_PI                               ((ESC_TRANSITION)MAKE_WORD(ESC_STATE_PREOP, ESC_STATE_INIT))
#define ESC_TRANSITION_PP                               ((ESC_TRANSITION)MAKE_WORD(ESC_STATE_PREOP, ESC_STATE_PREOP))
#define ESC_TRANSITION_PS                               ((ESC_TRANSITION)MAKE_WORD(ESC_STATE_PREOP, ESC_STATE_SAFEOP))
#define ESC_TRANSITION_SI                               ((ESC_TRANSITION)MAKE_WORD(ESC_STATE_SAFEOP, ESC_STATE_INIT))
#define ESC_TRANSITION_SO                               ((ESC_TRANSITION)MAKE_WORD(ESC_STATE_SAFEOP, ESC_STATE_OP))
#define ESC_TRANSITION_SP                               ((ESC_TRANSITION)MAKE_WORD(ESC_STATE_SAFEOP, ESC_STATE_PREOP))
#define ESC_TRANSITION_SS                               ((ESC_TRANSITION)MAKE_WORD(ESC_STATE_SAFEOP, ESC_STATE_SAFEOP))
#define ESC_TRANSITION_INVALID(tr)                      (((tr) == (ESC_TRANSITION)MAKE_WORD(ESC_STATE_INIT, ESC_STATE_SAFEOP)) || ((tr) == (ESC_TRANSITION)MAKE_WORD(ESC_STATE_INIT, ESC_STATE_OP)) || ((tr) == (ESC_TRANSITION)MAKE_WORD(ESC_STATE_PREOP, ESC_STATE_OP)) || ((tr) == (ESC_TRANSITION)MAKE_WORD(ESC_STATE_SAFEOP, ESC_STATE_BOOT)) || ((tr) == (ESC_TRANSITION)MAKE_WORD(ESC_STATE_PREOP, ESC_STATE_BOOT)) || ((tr) == (ESC_TRANSITION)MAKE_WORD(ESC_STATE_OP, ESC_STATE_BOOT)))


typedef uint8_t SM_TYPE;
#define SM_TYPE_INPUTS                                  ((SM_TYPE)0x00)
#define SM_TYPE_MBXIN                                   ((SM_TYPE)0x02)
#define SM_TYPE_OUTPUTS                                 ((SM_TYPE)0x04)
#define SM_TYPE_MBXOUT                                  ((SM_TYPE)0x06)
#define SM_TYPE_MBXIN_BOOTSTRAP                         ((SM_TYPE)0x82)
#define SM_TYPE_MBXOUT_BOOTSTRAP                        ((SM_TYPE)0x86)
#define SM_TYPE_MASK                                    (REG_MASK_SMCONTROL_TYPE | REG_MASK_SMCONTROL_BOOTSTRAP)

#define SM_TYPE_TO_STRING(smt)                          (((smt) == SM_TYPE_INPUTS) ? "Inputs" : ((smt) == SM_TYPE_MBXIN) ? "MBoxIn" :     \
                                                         ((smt) == SM_TYPE_OUTPUTS) ? "Outputs" : ((smt) == SM_TYPE_MBXOUT) ? "MBoxOut" : \
                                                         ((smt) == SM_TYPE_MBXIN_BOOTSTRAP) ? "MBoxInBootstrap" :                         \
                                                         ((smt) == SM_TYPE_MBXOUT_BOOTSTRAP) ? "MBoxOutBootstrap" : "Unknown SM Type!")

typedef uint8_t ESS_SM;
#define ESS_SM_NONE                                     ((ESS_SM)0xff)
/* Usually of type "MBoxOut" (Master writes) */
#define ESS_SM_0                                        ((ESS_SM)0x00)
/* Usually of type "MBoxIn" (Master reads) */
#define ESS_SM_1                                        ((ESS_SM)0x01)
/* Usually of type "Outputs" (Master writes) */
#define ESS_SM_2                                        ((ESS_SM)0x02)
/* Usually of type "Inputs" (Master reads) */
#define ESS_SM_3                                        ((ESS_SM)0x03)
#define ESS_SM_4                                        ((ESS_SM)0x04)
#define ESS_SM_5                                        ((ESS_SM)0x05)
#define ESS_SM_6                                        ((ESS_SM)0x06)
#define ESS_SM_7                                        ((ESS_SM)0x07)
#define ESS_SM_MAX_COUNT                                ((ESS_SM)0x20)

#define MBX_TYPE_ERROR                                  ((uint8_t)0x00)
#define MBX_TYPE_AOE                                    ((uint8_t)0x01)
#define MBX_TYPE_EOE                                    ((uint8_t)0x02)
#define MBX_TYPE_COE                                    ((uint8_t)0x03)
#define MBX_TYPE_FOE                                    ((uint8_t)0x04)
#define MBX_TYPE_SOE                                    ((uint8_t)0x05)
#define MBX_TYPE_VOE                                    ((uint8_t)0x0f)
#define MBX_TYPE_TO_STRING(mbt)                         ((mbt) == MBX_TYPE_ERROR ? "Error" : (mbt) == MBX_TYPE_AOE ? "AoE" : (mbt) == MBX_TYPE_EOE ? "EoE" : (mbt) == MBX_TYPE_COE ? "CoE" : (mbt) == MBX_TYPE_FOE ? "FoE" : (mbt) == MBX_TYPE_SOE ? "SoE" : (mbt) == MBX_TYPE_VOE ? "VoE" : "Unknown")

#define MBX_HEADERLEN                                   (6)
/* Use with ESS_MBX_PACKET->typeAndCounter */
#define MBX_HEADER_GET_COUNTER(v8)                      (((v8) >> 4) & 0x07)
#define MBX_HEADER_GET_CHANNEL(v8)                      ((v8) & 0x3f)
#define MBX_HEADER_GET_PRIORITY(v8)                     (((v8) >> 6) & 0x03)
/* Use with ESS_MBX_PACKET->typeAndCounter */
#define MBX_HEADER_GET_TYPE(v8)                         ((v8) & 0x0f)
/* Use with ESS_MBX_PACKET->typeAndCounter */
#define MBX_HEADER_MAKE_TYPEANDCOUNTER(typ, ctr)        ((uint8_t)((((ctr) & 0x07) << 4) | ((typ) & 0x0f)))	/*lint -e(845) */

typedef uint16_t Mbx_Err;
#define MBX_ERR_SUCCESS                                 ((Mbx_Err)0x0000)
#define MBX_ERR_SYNTAX                                  ((Mbx_Err)0x0001)
#define MBX_ERR_PROTOCOLNOTSUPPORTED                    ((Mbx_Err)0x0002)
#define MBX_ERR_CHANNELINVALID                          ((Mbx_Err)0x0003)
#define MBX_ERR_SERVICENOTSUPPORTED                     ((Mbx_Err)0x0004)
#define MBX_ERR_HEADERINVALID                           ((Mbx_Err)0x0005)
#define MBX_ERR_LENTOOSHORT                             ((Mbx_Err)0x0006)
#define MBX_ERR_NORESOURCES                             ((Mbx_Err)0x0007)
#define MBX_ERR_LENINVALID                              ((Mbx_Err)0x0008)
/* No ETG defined code, just used within ess to signal that no reply packet shall be sent */
#define MBX_ERR_ESS_NOREPLY                             ((Mbx_Err)0x0e5d)

#define REG_MASK_DLSTATUS_ENHLINKDETECTION              ((uint16_t)0x0004)

    /* Mask/Values of the AL Status register (0x130:0x131) */
#define REG_MASK_ALSTATUS_ERRIND                        ((uint16_t)0x0010)  /* Error Ind             */
#define REG_MASK_ALSTATUS_LOADDEVID                     ((uint16_t)0x0020)  /* Device identification */

    /* Mask/Values of the AL Control register (0x120:0x121) */
#define REG_MASK_ALCONTROL_STATE                        ((uint16_t)0x000f)
#define REG_MASK_ALCONTROL_ERRIND                       ((uint16_t)0x0010)  /* Error Ind Acknowledge */
#define REG_MASK_ALCONTROL_LOADDEVID                    ((uint16_t)0x0020)  /* Device ID request     */

#define REG_MASK_PDICONTROL_DEVEMULATION                ((uint16_t)0x0100)
#define REG_MASK_PDICONTROL_ENHLINKDETECTION            ((uint16_t)0x0200)
#define REG_MASK_PDICFG_SYNC0_OUTPUT                    ((uint8_t)0x04)
#define REG_MASK_PDICFG_SYNC0_MAPPED                    ((uint8_t)0x08)
#define REG_MASK_PDICFG_SYNC1_OUTPUT                    ((uint8_t)0x40)
#define REG_MASK_PDICFG_SYNC1_MAPPED                    ((uint8_t)0x80)

    /* Mask/Values of the AL Event Request register (0x220:0x223) */
#define REG_MASK_ALEVENT_CONTROLEVENT                   ((uint32_t)0x00000001)
#define REG_MASK_ALEVENT_DCLATCHEVENT                   ((uint32_t)0x00000002)
#define REG_MASK_ALEVENT_SYNC0EVENT                     ((uint32_t)0x00000004)
#define REG_MASK_ALEVENT_SYNC1EVENT                     ((uint32_t)0x00000008)
#define REG_MASK_ALEVENT_SMCHANGED                      ((uint32_t)0x00000010)
#define REG_MASK_ALEVENT_EEPROMEVENT                    ((uint32_t)0x00000020)
#define REG_MASK_ALEVENT_PDWDEXPIRED                    ((uint32_t)0x00000040)
#define REG_MASK_ALEVENT_SMINTERRUPT                    ((uint32_t)0x00ffff00)
#define REG_MASK_ALEVENT_SM(sm)                         ((uint32_t)(0x100 << (sm)))
#define REG_MASK_EEPROMCONFIGURATION_PDICONTROL         ((uint8_t)0x01)
#define REG_MASK_EEPROMCONFIGURATION_FORCEECAT          ((uint8_t)0x02)
#define REG_MASK_EEPROMPDIACCESSSTATE_PDIACCESS         ((uint8_t)0x01)
#define REG_MASK_EEPROMCTRLSTATUS_ECATWRITEENABLE       ((uint16_t)0x0001)
#define REG_MASK_EEPROMCTRLSTATUS_EMULATION             ((uint16_t)0x0020)
#define REG_MASK_EEPROMCTRLSTATUS_READ8BYTES            ((uint16_t)0x0040)
#define REG_MASK_EEPROMCTRLSTATUS_ALGO                  ((uint16_t)0x0080)
#define REG_MASK_EEPROMCTRLSTATUS_CMDREG                ((uint16_t)0x0700)
#define REG_MASK_EEPROMCTRLSTATUS_CMDREG_IDLE           ((uint16_t)0x0000)
#define REG_MASK_EEPROMCTRLSTATUS_CMDREG_READ           ((uint16_t)0x0100)
#define REG_MASK_EEPROMCTRLSTATUS_CMDREG_WRITE          ((uint16_t)0x0200)
#define REG_MASK_EEPROMCTRLSTATUS_CMDREG_RELOAD         ((uint16_t)0x0400)
#define REG_MASK_EEPROMCTRLSTATUS_CRCERR                ((uint16_t)0x0800)
#define REG_MASK_EEPROMCTRLSTATUS_LOADSTATE             ((uint16_t)0x1000)
#define REG_MASK_EEPROMCTRLSTATUS_ACKCMDERR             ((uint16_t)0x2000)
#define REG_MASK_EEPROMCTRLSTATUS_ERRWRITEENABLE        ((uint16_t)0x4000)
#define REG_MASK_EEPROMCTRLSTATUS_BUSY                  ((uint16_t)0x8000)
#define REG_MASK_EEPROMCTRLSTATUS_ERRBITS               ((uint16_t)(REG_MASK_EEPROMCTRLSTATUS_CRCERR    |   \
                                                                    REG_MASK_EEPROMCTRLSTATUS_LOADSTATE |   \
                                                                    REG_MASK_EEPROMCTRLSTATUS_ACKCMDERR |   \
                                                                    REG_MASK_EEPROMCTRLSTATUS_ERRWRITEENABLE))


#define REG_MASK_SMCONTROL_DISABLE                      ((uint8_t)0x01)
#define REG_MASK_SMCONTROL_OPMODE                       ((uint8_t)0x03)
#define REG_MASK_SMCONTROL_DIRECTION                    ((uint8_t)0x0c)
#define REG_MASK_SMCONTROL_TYPE                         ((uint8_t)(REG_MASK_SMCONTROL_OPMODE | REG_MASK_SMCONTROL_DIRECTION))
#define REG_MASK_SMCONTROL_ECATINT                      ((uint8_t)0x10)
#define REG_MASK_SMCONTROL_PDIINT                       ((uint8_t)0x20)
#define REG_MASK_SMCONTROL_WATCHDOG                     ((uint8_t)0x40)
#define REG_MASK_SMCONTROL_BOOTSTRAP                    ((uint8_t)0x80)     /* No real SM control bit. Only for internal use */
#define REG_MASK_SMSTATUS_MBXFULL                       ((uint8_t)0x08)
#define REG_MASK_SMACTIVATE_SMENABLE                    ((uint8_t)0x01)
#define REG_MASK_SMACTIVATE_REPEATREQ                   ((uint8_t)0x02)
#define REG_MASK_SMACTIVATE_LATCHECAT                   ((uint8_t)0x40)
#define REG_MASK_SMACTIVATE_LATCHPDI                    ((uint8_t)0x80)

typedef uint16_t REG_VAL_ALSTATUSCODE;
#define REG_VAL_ALSTATUSCODE_VENDOR(code)               (REG_VAL_ALSTATUSCODE)(0x8000 | (code & 0x7FFF))

    /* AL Status Codes defined in ETG.1000.6 and ETG.1020 */
#define REG_VAL_ALSTATUSCODE_NOERROR                    ((REG_VAL_ALSTATUSCODE)0x0000)
#define REG_VAL_ALSTATUSCODE_UNSPECIFIEDERROR           ((REG_VAL_ALSTATUSCODE)0x0001)
#define REG_VAL_ALSTATUSCODE_NOMEMORY                   ((REG_VAL_ALSTATUSCODE)0x0002)
#define REG_VAL_ALSTATUSCODE_INVALIDDEVICESETUP         ((REG_VAL_ALSTATUSCODE)0x0003)
#define REG_VAL_ALSTATUSCODE_FW_SII_NOT_MATCH           ((REG_VAL_ALSTATUSCODE)0x0006)
#define REG_VAL_ALSTATUSCODE_FW_UPDATE_FAILED           ((REG_VAL_ALSTATUSCODE)0x0007)
#define REG_VAL_ALSTATUSCODE_LICENSE_ERROR              ((REG_VAL_ALSTATUSCODE)0x000E)
#define REG_VAL_ALSTATUSCODE_INVALIDALCONTROL           ((REG_VAL_ALSTATUSCODE)0x0011)
#define REG_VAL_ALSTATUSCODE_UNKNOWNALCONTROL           ((REG_VAL_ALSTATUSCODE)0x0012)
#define REG_VAL_ALSTATUSCODE_BOOTNOTSUPP                ((REG_VAL_ALSTATUSCODE)0x0013)
#define REG_VAL_ALSTATUSCODE_NOVALIDFIRMWARE            ((REG_VAL_ALSTATUSCODE)0x0014)
#define REG_VAL_ALSTATUSCODE_INVALIDMBXCFGINBOOT        ((REG_VAL_ALSTATUSCODE)0x0015)
#define REG_VAL_ALSTATUSCODE_INVALIDMBXCFGINPREOP       ((REG_VAL_ALSTATUSCODE)0x0016)
#define REG_VAL_ALSTATUSCODE_INVALIDSMCFG               ((REG_VAL_ALSTATUSCODE)0x0017)
#define REG_VAL_ALSTATUSCODE_NOVALIDINPUTS              ((REG_VAL_ALSTATUSCODE)0x0018)
#define REG_VAL_ALSTATUSCODE_NOVALIDOUTPUTS             ((REG_VAL_ALSTATUSCODE)0x0019)
#define REG_VAL_ALSTATUSCODE_SYNCERROR                  ((REG_VAL_ALSTATUSCODE)0x001a)
#define REG_VAL_ALSTATUSCODE_SMWATCHDOG                 ((REG_VAL_ALSTATUSCODE)0x001b)
#define REG_VAL_ALSTATUSCODE_SYNCTYPESNOTCOMPATIBLE     ((REG_VAL_ALSTATUSCODE)0x001c)
#define REG_VAL_ALSTATUSCODE_INVALIDSMOUTCFG            ((REG_VAL_ALSTATUSCODE)0x001d)
#define REG_VAL_ALSTATUSCODE_INVALIDSMINCFG             ((REG_VAL_ALSTATUSCODE)0x001e)
#define REG_VAL_ALSTATUSCODE_INVALIDWDCFG               ((REG_VAL_ALSTATUSCODE)0x001f)
#define REG_VAL_ALSTATUSCODE_WAITFORCOLDSTART           ((REG_VAL_ALSTATUSCODE)0x0020)
#define REG_VAL_ALSTATUSCODE_WAITFORINIT                ((REG_VAL_ALSTATUSCODE)0x0021)
#define REG_VAL_ALSTATUSCODE_WAITFORPREOP               ((REG_VAL_ALSTATUSCODE)0x0022)
#define REG_VAL_ALSTATUSCODE_WAITFORSAFEOP              ((REG_VAL_ALSTATUSCODE)0x0023)
#define REG_VAL_ALSTATUSCODE_INVALIDINPUTMAPPING        ((REG_VAL_ALSTATUSCODE)0x0024)
#define REG_VAL_ALSTATUSCODE_INVALIDOUTPUTMAPPING       ((REG_VAL_ALSTATUSCODE)0x0025)
#define REG_VAL_ALSTATUSCODE_INCONSISTENTSETTINGS       ((REG_VAL_ALSTATUSCODE)0x0026)
#define REG_VAL_ALSTATUSCODE_FREERUNNOTSUPPORTED        ((REG_VAL_ALSTATUSCODE)0x0027)
#define REG_VAL_ALSTATUSCODE_SYNCHRONNOTSUPPORTED       ((REG_VAL_ALSTATUSCODE)0x0028)
#define REG_VAL_ALSTATUSCODE_FREERUNNEEDS3BUFFERMODE    ((REG_VAL_ALSTATUSCODE)0x0029)
#define REG_VAL_ALSTATUSCODE_BACKGROUNDWATCHDOG         ((REG_VAL_ALSTATUSCODE)0x002a)
#define REG_VAL_ALSTATUSCODE_NOVALIDINPUTSANDOUTPUTS    ((REG_VAL_ALSTATUSCODE)0x002b)
#define REG_VAL_ALSTATUSCODE_FATALSYNCERROR             ((REG_VAL_ALSTATUSCODE)0x002c)
#define REG_VAL_ALSTATUSCODE_NOSYNCERROR                ((REG_VAL_ALSTATUSCODE)0x002d)
#define REG_VAL_ALSTATUSCODE_CYCLETIMETOOSMALL          ((REG_VAL_ALSTATUSCODE)0x002e)
#define REG_VAL_ALSTATUSCODE_DCINVALIDSYNCCFG           ((REG_VAL_ALSTATUSCODE)0x0030)
#define REG_VAL_ALSTATUSCODE_DCINVALIDLATCHCFG          ((REG_VAL_ALSTATUSCODE)0x0031)
#define REG_VAL_ALSTATUSCODE_DCPLLSYNCERROR             ((REG_VAL_ALSTATUSCODE)0x0032)
#define REG_VAL_ALSTATUSCODE_DCSYNCIOERROR              ((REG_VAL_ALSTATUSCODE)0x0033)
#define REG_VAL_ALSTATUSCODE_DCSYNCMISSEDERROR          ((REG_VAL_ALSTATUSCODE)0x0034)
#define REG_VAL_ALSTATUSCODE_DCINVALIDSYNCCYCLETIME     ((REG_VAL_ALSTATUSCODE)0x0035)
#define REG_VAL_ALSTATUSCODE_DCSYNC0CYCLETIME           ((REG_VAL_ALSTATUSCODE)0x0036)
#define REG_VAL_ALSTATUSCODE_DCSYNC1CYCLETIME           ((REG_VAL_ALSTATUSCODE)0x0037)
#define REG_VAL_ALSTATUSCODE_MBXAOE                     ((REG_VAL_ALSTATUSCODE)0x0041)
#define REG_VAL_ALSTATUSCODE_MBXEOE                     ((REG_VAL_ALSTATUSCODE)0x0042)
#define REG_VAL_ALSTATUSCODE_MBXCOE                     ((REG_VAL_ALSTATUSCODE)0x0043)
#define REG_VAL_ALSTATUSCODE_MBXFOE                     ((REG_VAL_ALSTATUSCODE)0x0044)
#define REG_VAL_ALSTATUSCODE_MBXSOE                     ((REG_VAL_ALSTATUSCODE)0x0045)
#define REG_VAL_ALSTATUSCODE_MBXVOE                     ((REG_VAL_ALSTATUSCODE)0x004f)
#define REG_VAL_ALSTATUSCODE_EEPROMNOACCESS             ((REG_VAL_ALSTATUSCODE)0x0050)
#define REG_VAL_ALSTATUSCODE_EEPROMERROR                ((REG_VAL_ALSTATUSCODE)0x0051)
#define REG_VAL_ALSTATUSCODE_EXT_HARDWARE_NOT_READY     ((REG_VAL_ALSTATUSCODE)0x0052)
#define REG_VAL_ALSTATUSCODE_SLVRESTARTEDLOCALLY        ((REG_VAL_ALSTATUSCODE)0x0060)
#define REG_VAL_ALSTATUSCODE_DEVIDUPDATED               ((REG_VAL_ALSTATUSCODE)0x0061)
#define REG_VAL_ALSTATUSCODE_MODULE_ID_LIST_NOT_MATCH   ((REG_VAL_ALSTATUSCODE)0x0070)
#define REG_VAL_ALSTATUSCODE_APPCONTRAVAILABLE          ((REG_VAL_ALSTATUSCODE)0x00f0)

        /* esd salve stack specific AL Status Codes */
#define REG_VAL_ALSTATUSCODE_ESD_MAP_ASSIGNMISSING      ((REG_VAL_ALSTATUSCODE)0xB001)
#define REG_VAL_ALSTATUSCODE_ESD_MAP_ASSIGNOBJERR       ((REG_VAL_ALSTATUSCODE)0xB002)
#define REG_VAL_ALSTATUSCODE_ESD_MAP_PDOMISSING         ((REG_VAL_ALSTATUSCODE)0xB003)
#define REG_VAL_ALSTATUSCODE_ESD_MAP_PDOOBJERR          ((REG_VAL_ALSTATUSCODE)0xB004)
#define REG_VAL_ALSTATUSCODE_ESD_MAP_MAPPEDOBJMISSING   ((REG_VAL_ALSTATUSCODE)0xB005)
#define REG_VAL_ALSTATUSCODE_ESD_MAP_MAPPEDOBJERR       ((REG_VAL_ALSTATUSCODE)0xB006)
#define REG_VAL_ALSTATUSCODE_ESD_MAP_MAPPEDENTRYMISSING ((REG_VAL_ALSTATUSCODE)0xB007)
#define REG_VAL_ALSTATUSCODE_ESD_MAP_MAPPEDENTRYERR     ((REG_VAL_ALSTATUSCODE)0xB008)
#define REG_VAL_ALSTATUSCODE_ESD_CAN_INVALIDHANDLE      ((REG_VAL_ALSTATUSCODE)0xB010)
#define REG_VAL_ALSTATUSCODE_ESD_OTHERSIDEINVALSTATE    ((REG_VAL_ALSTATUSCODE)0xB011)
#define REG_VAL_ALSTATUSCODE_ESD_FLASHERROR             ((REG_VAL_ALSTATUSCODE)0xB012)

#define REG_VAL_ALSTATUSCODE_TO_STRING(sc)              (((sc) == 0x0000) ? "NOERROR" : \
                                                         ((sc) == 0x0001) ? "UNSPECIFIEDERROR" : \
                                                         ((sc) == 0x0002) ? "NOMEMORY" : \
                                                         ((sc) == 0x0011) ? "INVALIDALCONTROL" : \
                                                         ((sc) == 0x0012) ? "UNKNOWNALCONTROL" : \
                                                         ((sc) == 0x0013) ? "BOOTNOTSUPP" : \
                                                         ((sc) == 0x0014) ? "NOVALIDFIRMWARE" : \
                                                         ((sc) == 0x0015) ? "INVALIDMBXCFGINBOOT" : \
                                                         ((sc) == 0x0016) ? "INVALIDMBXCFGINPREOP" : \
                                                         ((sc) == 0x0017) ? "INVALIDSMCFG" : \
                                                         ((sc) == 0x0018) ? "NOVALIDINPUTS" : \
                                                         ((sc) == 0x0019) ? "NOVALIDOUTPUTS" : \
                                                         ((sc) == 0x001a) ? "SYNCERROR" : \
                                                         ((sc) == 0x001b) ? "SMWATCHDOG" : \
                                                         ((sc) == 0x001c) ? "SYNCTYPESNOTCOMPATIBLE" : \
                                                         ((sc) == 0x001d) ? "INVALIDSMOUTCFG" : \
                                                         ((sc) == 0x001e) ? "INVALIDSMINCFG" : \
                                                         ((sc) == 0x001f) ? "INVALIDWDCFG" : \
                                                         ((sc) == 0x0020) ? "WAITFORCOLDSTART" : \
                                                         ((sc) == 0x0021) ? "WAITFORINIT" : \
                                                         ((sc) == 0x0022) ? "WAITFORPREOP" : \
                                                         ((sc) == 0x0023) ? "WAITFORSAFEOP" : \
                                                         ((sc) == 0x0024) ? "INVALIDINPUTMAPPING" : \
                                                         ((sc) == 0x0025) ? "INVALIDOUTPUTMAPPING" : \
                                                         ((sc) == 0x0026) ? "INCONSISTENTSETTINGS" : \
                                                         ((sc) == 0x0027) ? "FREERUNNOTSUPPORTED" : \
                                                         ((sc) == 0x0028) ? "SYNCHRONNOTSUPPORTED" : \
                                                         ((sc) == 0x0029) ? "FREERUNNEEDS3BUFFERMODE" : \
                                                         ((sc) == 0x002a) ? "BACKGROUNDWATCHDOG" : \
                                                         ((sc) == 0x002b) ? "NOVALIDINPUTSANDOUTPUTS" : \
                                                         ((sc) == 0x002c) ? "FATALSYNCERROR" : \
                                                         ((sc) == 0x002d) ? "NOSYNCERROR" : \
                                                         ((sc) == 0x0030) ? "DCINVALIDSYNCCFG" : \
                                                         ((sc) == 0x0031) ? "DCINVALIDLATCHCFG" : \
                                                         ((sc) == 0x0032) ? "DCPLLSYNCERROR" : \
                                                         ((sc) == 0x0033) ? "DCSYNCIOERROR" : \
                                                         ((sc) == 0x0034) ? "DCSYNCMISSEDERROR" : \
                                                         ((sc) == 0x0035) ? "DCINVALIDSYNCCYCLETIME" : \
                                                         ((sc) == 0x0036) ? "DCSYNC0CYCLETIME" : \
                                                         ((sc) == 0x0037) ? "DCSYNC1CYCLETIME" : \
                                                         ((sc) == 0x0041) ? "MBXAOE" : \
                                                         ((sc) == 0x0042) ? "MBXEOE" : \
                                                         ((sc) == 0x0043) ? "MBXCOE" : \
                                                         ((sc) == 0x0044) ? "MBXFOE" : \
                                                         ((sc) == 0x0045) ? "MBXSOE" : \
                                                         ((sc) == 0x004f) ? "MBXVOE" : \
                                                         ((sc) == 0x0050) ? "EEPROMNOACCESS" : \
                                                         ((sc) == 0x0051) ? "EEPROMERROR" : \
                                                         ((sc) == 0x0060) ? "SLVRESTARTEDLOCALLY" : \
                                                         ((sc) == 0x0061) ? "DEVIDUPDATED" : \
                                                         ((sc) == 0x00f0) ? "APPCONTRAVAILABLE" : \
                                                         ((sc) == 0xb001) ? "ESD_MAP_ASSIGNMISSING" : \
                                                         ((sc) == 0xb002) ? "ESD_MAP_ASSIGNOBJERR" : \
                                                         ((sc) == 0xb003) ? "ESD_MAP_PDOMISSING" : \
                                                         ((sc) == 0xb004) ? "ESD_MAP_PDOOBJERR" : \
                                                         ((sc) == 0xb005) ? "ESD_MAP_MAPPEDOBJMISSING" : \
                                                         ((sc) == 0xb006) ? "ESD_MAP_MAPPEDOBJERR" : \
                                                         ((sc) == 0xb007) ? "ESD_MAP_MAPPEDENTRYMISSING" : \
                                                         ((sc) == 0xb008) ? "ESD_MAP_MAPPEDENTRYERR" : \
                                                         ((sc) == 0xb010) ? "ESD_CAN_INVALIDHANDLE" : \
                                                         ((sc) == 0xb011) ? "ESD_OTHERSIDEINVALSTATE" : \
                                                         ((sc) == 0xb012) ? "ESD_FLASHERROR" : "Unknown")

#define MBX_COE_HEADERPOS                               (0)
#define MBX_COE_HEADERLEN                               (2)
#define MBX_COE_GET_SERVICE(v16)                        ((v16) >> 12)
#define MBX_COE_GET_NUMBER(v16)                         ((v16) & 0x01ff)

#define MBX_COE_SERVICE_EMERGENCY                       ((uint8_t)0x01)
#define MBX_COE_SERVICE_SDOREQUEST                      ((uint8_t)0x02)
#define MBX_COE_SERVICE_SDORESPONSE                     ((uint8_t)0x03)
#define MBX_COE_SERVICE_TXPDO                           ((uint8_t)0x04)
#define MBX_COE_SERVICE_RXPDO                           ((uint8_t)0x05)
#define MBX_COE_SERVICE_TXPDORR                         ((uint8_t)0x06)
#define MBX_COE_SERVICE_RXPDORR                         ((uint8_t)0x07)
#define MBX_COE_SERVICE_SDOINFO                         ((uint8_t)0x08)

#define MBX_COE_SDOREQ_HEADERPOS                        (MBX_COE_HEADERLEN)
#define MBX_COE_SDOREQ_HEADERLEN                        (8)
#define MBX_COE_SDOREQ_HEADER_MASK_SIZEIND              ((uint8_t)0x01)
#define MBX_COE_SDOREQ_HEADER_MASK_DOWNL_LAST_SEG       ((uint8_t)0x01)
#define MBX_COE_SDOREQ_HEADER_MASK_DOWNLSEGSIZE(v8)     (((v8) & 0x0e) >> 1)
#define MBX_COE_SDOREQ_HEADER_MASK_TRANSFTYPE           ((uint8_t)0x02)
#define MBX_COE_SDOREQ_HEADER_GET_DATASETSIZE(v8)       (((v8) & 0x0c) >> 2)
#define MBX_COE_SDOREQ_HEADER_MASK_COMPLACCESS          ((uint8_t)0x10)
#define MBX_COE_SDOREQ_HEADER_MASK_TOGGLEBIT            ((uint8_t)0x10)
#define MBX_COE_SDOREQ_HEADER_GET_CMDSPEC(v8)           (((v8) & 0xe0) >> 5)
#define MBX_COE_SDOREQ_CMDSPECIFIER_DOWNLOADSEGMENT     ((uint8_t)0x00)
#define MBX_COE_SDOREQ_CMDSPECIFIER_DOWNLOAD            ((uint8_t)0x01)
#define MBX_COE_SDOREQ_CMDSPECIFIER_UPLOAD              ((uint8_t)0x02)
#define MBX_COE_SDOREQ_CMDSPECIFIER_UPLOADSEGMENT       ((uint8_t)0x03)
#define MBX_COE_SDOREQ_CMDSPECIFIER_ABORT               ((uint8_t)0x04)

/*lint -emacro(506, MBX_COE_SDORESP_HDR) (Constant value Boolean) */
/*lint -emacro(845, MBX_COE_SDORESP_HDR) (The left/right argument of operator .. is certain to be ..) */
#define MBX_COE_SDORESP_HDR(sI, exp, dss, cmpl, cmd)    (((sI) ? 1 : 0) | ((exp) ? 2 : 0) | (((dss) & 0x03) << 2) | ((cmpl) ? 0x10 : 0) | (((cmd) & 0x07) << 5))
/*lint -emacro(506, MBX_COE_SDORESP_UPLSEG_HDR) (Constant value Boolean) */
/*lint -emacro(845, MBX_COE_SDORESP_UPLSEG_HDR) (The left/right argument of operator .. is certain to be ..) */
#define MBX_COE_SDORESP_UPLSEG_HDR(more, sds, toggle)   (((more) ? 1 : 0) | (((sds) & 0x07) << 1) | ((toggle) ? 0x10 : 0))
#define MBX_COE_SDORESP_DOWNLSEG_HDR(toggle)            (((toggle) ? 0x10 : 0) | (0x20))
#define MBX_COE_SDORESP_CMDSPECIFIER_UPLOADSEGMENT      ((uint8_t)0x00)
#define MBX_COE_SDORESP_CMDSPECIFIER_DOWNLOADSEGMENT    ((uint8_t)0x01)
#define MBX_COE_SDORESP_CMDSPECIFIER_UPLOAD             ((uint8_t)0x02)
#define MBX_COE_SDORESP_CMDSPECIFIER_DOWNLOAD           ((uint8_t)0x03)

#define MBX_COE_SDOINFO_HEADERPOS                       (MBX_COE_HEADERLEN)
#define MBX_COE_SDOINFO_HEADERLEN                       (4)
#define MBX_COE_SDOINFO_HEADER_MASK_INCOMPLETE          ((uint8_t)0x80)
#define MBX_COE_SDOINFO_HEADER_MASK_OPCODE              ((uint8_t)0x7f)
#define MBX_COE_SDOINFO_DATAPOS                         ((MBX_COE_SDOINFO_HEADERPOS) + (MBX_COE_SDOINFO_HEADERLEN))
#define MBX_COE_SDOINFO_OP_ODLISTREQ                    ((uint8_t)0x01)
#define MBX_COE_SDOINFO_OP_ODLISTRESP                   ((uint8_t)0x02)
#define MBX_COE_SDOINFO_OP_OBJREQ                       ((uint8_t)0x03)
#define MBX_COE_SDOINFO_OP_OBJRESP                      ((uint8_t)0x04)
#define MBX_COE_SDOINFO_OP_ENTRYREQ                     ((uint8_t)0x05)
#define MBX_COE_SDOINFO_OP_ENTRYRESP                    ((uint8_t)0x06)
#define MBX_COE_SDOINFO_OP_ERRREQ                       ((uint8_t)0x07)
#define MBX_COE_SDOINFO_ODLISTREQ_NUMBERS               ((uint16_t)0x0000)
#define MBX_COE_SDOINFO_ODLISTREQ_ALLOBJECTS            ((uint16_t)0x0001)
#define MBX_COE_SDOINFO_ODLISTREQ_RXPDOS                ((uint16_t)0x0002)
#define MBX_COE_SDOINFO_ODLISTREQ_TXPDOS                ((uint16_t)0x0003)
#define MBX_COE_SDOINFO_ODLISTREQ_REPLACEMOBJECTS       ((uint16_t)0x0004)
#define MBX_COE_SDOINFO_ODLISTREQ_STARTUPOBJECTS        ((uint16_t)0x0005)

#define COE_OD_LISTCOUNT                                (5)

typedef uint8_t COE_CODE;
#define COE_CODE_VARIABLE                               ((COE_CODE)0x07)
#define COE_CODE_ARRAY                                  ((COE_CODE)0x08)
#define COE_CODE_RECORD                                 ((COE_CODE)0x09)

typedef uint8_t COE_VALUEINFO;
#define COE_VALUEINFO_NONE                              ((COE_VALUEINFO)0x00)
#define COE_VALUEINFO_UNITTYPE                          ((COE_VALUEINFO)0x08)
#define COE_VALUEINFO_DEFAULTVALUE                      ((COE_VALUEINFO)0x10)
#define COE_VALUEINFO_MINVALUE                          ((COE_VALUEINFO)0x20)
#define COE_VALUEINFO_MAXVALUE                          ((COE_VALUEINFO)0x40)

typedef uint16_t COE_ACCESS;
#define COE_ACCESS_R_PREOP                              ((COE_ACCESS)0x0001)
#define COE_ACCESS_R_SAFEOP                             ((COE_ACCESS)0x0002)
#define COE_ACCESS_R_OP                                 ((COE_ACCESS)0x0004)
/* Read in all states */
#define COE_ACCESS_R                                    ((COE_ACCESS)(COE_ACCESS_R_PREOP | COE_ACCESS_R_SAFEOP | COE_ACCESS_R_OP))
#define COE_ACCESS_W_PREOP                              ((COE_ACCESS)0x0008)
#define COE_ACCESS_W_SAFEOP                             ((COE_ACCESS)0x0010)
#define COE_ACCESS_W_OP                                 ((COE_ACCESS)0x0020)
/* Write in all states */
#define COE_ACCESS_W                                    ((COE_ACCESS)(COE_ACCESS_W_PREOP | COE_ACCESS_W_SAFEOP | COE_ACCESS_W_OP))
/* Read and write in all states */
#define COE_ACCESS_RW                                   ((COE_ACCESS)(COE_ACCESS_R | COE_ACCESS_W))
#define COE_ACCESS_RXMAPPABLE                           ((COE_ACCESS)0x0040)
#define COE_ACCESS_TXMAPPABLE                           ((COE_ACCESS)0x0080)
#define COE_ACCESS_RXTXMAPPABLE                         ((COE_ACCESS)(COE_ACCESS_RXMAPPABLE | COE_ACCESS_TXMAPPABLE))
#define COE_ACCESS_BACKUPOBJECT                         ((COE_ACCESS)0x0100)
#define COE_ACCESS_SETTINGSOBJECT                       ((COE_ACCESS)0x0200)
#define COE_ACCESS_SAFEINPUT                            ((COE_ACCESS)0x0400)
#define COE_ACCESS_SAFEOUTPUT                           ((COE_ACCESS)0x0800)
#define COE_ACCESS_SAFEPARAMETER                        ((COE_ACCESS)0x1000)
#define COE_ACCESS_SAFEVARIABLE                         ((COE_ACCESS)(COE_ACCESS_SAFEINPUT | COE_ACCESS_SAFEOUTPUT | COE_ACCESS_SAFEPARAMETER))
#define COE_ACCESS_R_ALLOWED(acc, currState)            (((currState == ESC_STATE_OP) && ((acc) & COE_ACCESS_R_OP)) || ((currState == ESC_STATE_SAFEOP) && ((acc) & COE_ACCESS_R_SAFEOP)) || ((currState == ESC_STATE_PREOP) && ((acc) & COE_ACCESS_R_PREOP)))
#define COE_ACCESS_W_ALLOWED(acc, currState)            (((currState == ESC_STATE_OP) && ((acc) & COE_ACCESS_W_OP)) || ((currState == ESC_STATE_SAFEOP) && ((acc) & COE_ACCESS_W_SAFEOP)) || ((currState == ESC_STATE_PREOP) && ((acc) & COE_ACCESS_W_PREOP)))

typedef uint16_t COE_DATATYPE;
#define COE_DATATYPE_INVALID                            ((COE_DATATYPE)0x0000)
#define COE_DATATYPE_BOOL                               ((COE_DATATYPE)0x0001)
/* int8_t */
#define COE_DATATYPE_SINT                               ((COE_DATATYPE)0x0002)
/* int16_t */
#define COE_DATATYPE_INT                                ((COE_DATATYPE)0x0003)
/* int32_t */
#define COE_DATATYPE_DINT                               ((COE_DATATYPE)0x0004)
/* uint8_t */
#define COE_DATATYPE_USINT                              ((COE_DATATYPE)0x0005)
/* uint16_t */
#define COE_DATATYPE_UINT                               ((COE_DATATYPE)0x0006)
/* uint32_t */
#define COE_DATATYPE_UDINT                              ((COE_DATATYPE)0x0007)
/* 32 bit (float) */
#define COE_DATATYPE_REAL                               ((COE_DATATYPE)0x0008)
/* Also called "Visible String" */
#define COE_DATATYPE_STRING                             ((COE_DATATYPE)0x0009)
#define COE_DATATYPE_OCTETSTRING                        ((COE_DATATYPE)0x000a)
#define COE_DATATYPE_WSTRING                            ((COE_DATATYPE)0x000b)
#define COE_DATATYPE_TIMEOFDAY                          ((COE_DATATYPE)0x000c)
#define COE_DATATYPE_TIMEDIFF                           ((COE_DATATYPE)0x000d)
#define COE_DATATYPE_DOMAIN                             ((COE_DATATYPE)0x000f)
#define COE_DATATYPE_INT24                              ((COE_DATATYPE)0x0010)
/* 64 bit (double) */
#define COE_DATATYPE_LREAL                              ((COE_DATATYPE)0x0011)
#define COE_DATATYPE_INT40                              ((COE_DATATYPE)0x0012)
#define COE_DATATYPE_INT48                              ((COE_DATATYPE)0x0013)
#define COE_DATATYPE_INT56                              ((COE_DATATYPE)0x0014)
/* int64_t */
#define COE_DATATYPE_LINT                               ((COE_DATATYPE)0x0015)
#define COE_DATATYPE_UINT24                             ((COE_DATATYPE)0x0016)
#define COE_DATATYPE_UINT40                             ((COE_DATATYPE)0x0018)
#define COE_DATATYPE_UINT48                             ((COE_DATATYPE)0x0019)
#define COE_DATATYPE_UINT56                             ((COE_DATATYPE)0x001a)
/* uint64_t */
#define COE_DATATYPE_ULINT                              ((COE_DATATYPE)0x001b)
/* #define COE_DATATYPE_GUID                               ((COE_DATATYPE)0x001d) */
/* #define COE_DATATYPE_BYTE                               ((COE_DATATYPE)0x001e) */
#define COE_DATATYPE_PDOCOMMPAR                         ((COE_DATATYPE)0x0020)
#define COE_DATATYPE_PDOMAPPING                         ((COE_DATATYPE)0x0021)
#define COE_DATATYPE_SDOPARAMETER                       ((COE_DATATYPE)0x0022)
#define COE_DATATYPE_IDENTITY                           ((COE_DATATYPE)0x0023)
#define COE_DATATYPE_COMMANDPAR                         ((COE_DATATYPE)0x0025)
#define COE_DATATYPE_SYNCPAR                            ((COE_DATATYPE)0x0029)
#define COE_DATATYPE_BITARR8                            ((COE_DATATYPE)0x002d)
#define COE_DATATYPE_BITARR16                           ((COE_DATATYPE)0x002e)
#define COE_DATATYPE_BITARR32                           ((COE_DATATYPE)0x002f)
#define COE_DATATYPE_BIT1                               ((COE_DATATYPE)0x0030)
#define COE_DATATYPE_BIT2                               ((COE_DATATYPE)0x0031)
#define COE_DATATYPE_BIT3                               ((COE_DATATYPE)0x0032)
#define COE_DATATYPE_BIT4                               ((COE_DATATYPE)0x0033)
#define COE_DATATYPE_BIT5                               ((COE_DATATYPE)0x0034)
#define COE_DATATYPE_BIT6                               ((COE_DATATYPE)0x0035)
#define COE_DATATYPE_BIT7                               ((COE_DATATYPE)0x0036)
#define COE_DATATYPE_BIT8                               ((COE_DATATYPE)0x0037)
#define COE_DATATYPE_FSOE_FRAME_ELEMENTS                ((COE_DATATYPE)0x0285)
#define COE_DATATYPE_ENUMFIRST                          ((COE_DATATYPE)0x0800)
#define COE_DATATYPE_ENUMLAST                           ((COE_DATATYPE)0x0fff)

typedef uint32_t COE_ABORTCODE;
#define COE_ABORTCODE_NONE                              ((COE_ABORTCODE)0x00000000)
#define COE_ABORTCODE_TOGGLE                            ((COE_ABORTCODE)0x05030000)
#define COE_ABORTCODE_TIMEOUT                           ((COE_ABORTCODE)0x05040000)
#define COE_ABORTCODE_CCS_SCS                           ((COE_ABORTCODE)0x05040001)
#define COE_ABORTCODE_MEMORY                            ((COE_ABORTCODE)0x05040005)
#define COE_ABORTCODE_ACCESS                            ((COE_ABORTCODE)0x06010000)
#define COE_ABORTCODE_WRITEONLY                         ((COE_ABORTCODE)0x06010001)
#define COE_ABORTCODE_READONLY                          ((COE_ABORTCODE)0x06010002)
#define COE_ABORTCODE_SI0_MUSTBE0_FOR_WRITEACCESS       ((COE_ABORTCODE)0x06010003)
#define COE_ABORTCODE_UNSUPP_TYPE_FOR_COMPL_ACCESS      ((COE_ABORTCODE)0x06010004)
#define COE_ABORTCODE_MAILBOX_TOO_SMALL                 ((COE_ABORTCODE)0x06010005)
#define COE_ABORTCODE_INVALID_STATE_FOR_MAPPED_OBJ      ((COE_ABORTCODE)0x06010006)
#define COE_ABORTCODE_INDEX                             ((COE_ABORTCODE)0x06020000)
#define COE_ABORTCODE_PDO_MAP                           ((COE_ABORTCODE)0x06040041)
#define COE_ABORTCODE_PDO_LEN                           ((COE_ABORTCODE)0x06040042)
#define COE_ABORTCODE_P_INCOMP                          ((COE_ABORTCODE)0x06040043)
#define COE_ABORTCODE_I_INCOMP                          ((COE_ABORTCODE)0x06040047)
#define COE_ABORTCODE_HARDWARE                          ((COE_ABORTCODE)0x06060000)
#define COE_ABORTCODE_LEN                               ((COE_ABORTCODE)0x06070010)
#define COE_ABORTCODE_LEN_TOO_HIGH                      ((COE_ABORTCODE)0x06070012)
#define COE_ABORTCODE_LEN_TOO_LOW                       ((COE_ABORTCODE)0x06070013)
#define COE_ABORTCODE_SUBINDEX                          ((COE_ABORTCODE)0x06090011)
#define COE_ABORTCODE_DATA                              ((COE_ABORTCODE)0x06090030)
#define COE_ABORTCODE_DATA_TOO_HIGH                     ((COE_ABORTCODE)0x06090031)
#define COE_ABORTCODE_DATA_TOO_LOW                      ((COE_ABORTCODE)0x06090032)
#define COE_ABORTCODE_MODULE_MISMATCH                   ((COE_ABORTCODE)0x06090033)
#define COE_ABORTCODE_MINMAX                            ((COE_ABORTCODE)0x06090036)
#define COE_ABORTCODE_GENERAL                           ((COE_ABORTCODE)0x08000000)
#define COE_ABORTCODE_STORE                             ((COE_ABORTCODE)0x08000020)
#define COE_ABORTCODE_STORE_LOCAL                       ((COE_ABORTCODE)0x08000021)
#define COE_ABORTCODE_STORE_DEVICE_STATE                ((COE_ABORTCODE)0x08000022)
#define COE_ABORTCODE_DICTIONARY                        ((COE_ABORTCODE)0x08000023)

#define COE_OBJ_DEVICE_TYPE                             ((uint16_t)0x1000)  /* ETG.1000.6 */
#define COE_OBJ_ERROR_REGISTER                          ((uint16_t)0x1001)  /* ETG.1000.6 */
#define COE_OBJ_DEVICE_NAME                             ((uint16_t)0x1008)  /* ETG.1000.6 */
#define COE_OBJ_HARDWARE_VER                            ((uint16_t)0x1009)  /* ETG.1000.6 */
#define COE_OBJ_SOFTWARE_VER                            ((uint16_t)0x100A)  /* ETG.1000.6 */
#define COE_OBJ_IDENTITY                                ((uint16_t)0x1018)  /* ETG.1000.6 */
#define COE_OBJ_DEVID_RELOAD                            ((uint16_t)0x10E0)  /* ETG.1020   */
#define COE_OBJ_DIAG_HISTORY                            ((uint16_t)0x10F3)  /* ETG.1020   */
#define COE_OBJ_RX_PDO_PARAMETER                        ((uint16_t)0x1400)  /* ETG.1020   */
#define COE_OBJ_RX_PDO_MAPPING                          ((uint16_t)0x1600)  /* ETG.1000.6 */
#define COE_OBJ_TX_PDO_PARAMETER                        ((uint16_t)0x1800)  /* ETG.1020   */
#define COE_OBJ_TX_PDO_MAPPING                          ((uint16_t)0x1A00)  /* ETG.1000.6 */
#define COE_OBJ_OUTPUT_SM_PARAMETER                     ((uint16_t)0x1C32)  /* ETG.1020   */
#define COE_OBJ_INPUT_SM_PARAMETER                      ((uint16_t)0x1C33)  /* ETG.1020   */
#define COE_OBJ_MDP_INPUT_DATA                          ((uint16_t)0x6000)  /* ETG.5001   */
#define COE_OBJ_MDP_OUTPUT_DATA                         ((uint16_t)0x7000)  /* ETG.5001   */
#define COE_OBJ_MDP_CONFIGURATION_DATA                  ((uint16_t)0x8000)  /* ETG.5001   */
#define COE_OBJ_MDP_INFO_DATA                           ((uint16_t)0x9000)  /* ETG.5001   */
#define COE_OBJ_MDP_DIAGNOSIS_DATA                      ((uint16_t)0xA000)  /* ETG.5001   */
#define COE_OBJ_MDP                                     ((uint16_t)0xF000)  /* ETG.5001   */
#define COE_OBJ_MDP_DETECT_MODULES_CMD                  ((uint16_t)0xF002)  /* ETG.5001   */
#define COE_OBJ_MDP_PDO_GROUP_ALIGNMENT_PDO_NUMBERS     ((uint16_t)0xF00E)  /* ETG.5001   */
#define COE_OBJ_MDP_PDO_GROUP_ALIGNMENT                 ((uint16_t)0xF00F)  /* ETG.5001   */
#define COE_OBJ_MDP_MODULE_PROFILE_LIST                 ((uint16_t)0xF010)  /* ETG.5001   */
#define COE_OBJ_MDP_CONFIGURED_ADDRESS_LIST             ((uint16_t)0xF020)  /* ETG.5001   */
#define COE_OBJ_MDP_CONFIGURED_MODULE_IDENT_LIST        ((uint16_t)0xF030)  /* ETG.5001   */
#define COE_OBJ_MDP_DETECTED_ADDRESS_LIST               ((uint16_t)0xF040)  /* ETG.5001   */
#define COE_OBJ_MDP_DETECTED_MODULE_IDENT_LIST          ((uint16_t)0xF050)  /* ETG.5001   */
#define COE_OBJ_MDP_DEVICE_STATUS                       ((uint16_t)0xF100)  /* ETG.5001   */
#define COE_OBJ_MDP_DEVICE_DIAGNOSIS                    ((uint16_t)0xF110)  /* ETG.5001   */
#define COE_OBJ_MDP_DEVICE_STATISTICS                   ((uint16_t)0xF120)  /* ETG.5001   */
#define COE_OBJ_MDP_DEVICE_CONTROL                      ((uint16_t)0xF200)  /* ETG.5001   */
#define COE_OBJ_MDP_DEVICE_INPUT_DATA                   ((uint16_t)0xF600)  /* ETG.5001   */
#define COE_OBJ_MDP_DEVICE_OUTPUT_DATA                  ((uint16_t)0xF700)  /* ETG.5001   */
#define COE_OBJ_MDP_DEVICE_CONFIG_DATA                  ((uint16_t)0xF800)  /* ETG.5001   */
#define COE_OBJ_MDP_DEVICE_COMMAND                      ((uint16_t)0xFB00)  /* ETG.5001   */

#define FOE_HEADERLEN                                   (2)
#define FOE_PACKETNOLEN                                 (4)
#define FOE_OPCODE_NONE                                 ((uint8_t)0x00)
#define FOE_OPCODE_READ                                 ((uint8_t)0x01)
#define FOE_OPCODE_WRITE                                ((uint8_t)0x02)
#define FOE_OPCODE_DATA                                 ((uint8_t)0x03)
#define FOE_OPCODE_ACK                                  ((uint8_t)0x04)
#define FOE_OPCODE_ERROR                                ((uint8_t)0x05)
#define FOE_OPCODE_BUSY                                 ((uint8_t)0x06)

typedef uint32_t FOE_ERRORCODE;
#define FOE_ERRCODE_NONE                                ((FOE_ERRORCODE)0x00000000)
#define FOE_ERRCODE_UNDEFINED                           ((FOE_ERRORCODE)0x00008000)
#define FOE_ERRCODE_NOTFOUND                            ((FOE_ERRORCODE)0x00008001)
#define FOE_ERRCODE_ACCESSDENIED                        ((FOE_ERRORCODE)0x00008002)
#define FOE_ERRCODE_DISKFULL                            ((FOE_ERRORCODE)0x00008003)
#define FOE_ERRCODE_ILLEGAL                             ((FOE_ERRORCODE)0x00008004)
#define FOE_ERRCODE_WRONGPACKETNO                       ((FOE_ERRORCODE)0x00008005)
#define FOE_ERRCODE_ALREADYEXISTS                       ((FOE_ERRORCODE)0x00008006)
#define FOE_ERRCODE_NOUSER                              ((FOE_ERRORCODE)0x00008007)
#define FOE_ERRCODE_BOOTSTRAPONLY                       ((FOE_ERRORCODE)0x00008008)
#define FOE_ERRCODE_NOBOOTSTRAP                         ((FOE_ERRORCODE)0x00008009)
#define FOE_ERRCODE_NORIGHTS                            ((FOE_ERRORCODE)0x0000800a)
#define FOE_ERRCODE_PROGRAMERROR                        ((FOE_ERRORCODE)0x0000800b)
#define FOE_ERRCODE_INVALIDCHECKSUM                     ((FOE_ERRORCODE)0x0000800c)
#define FOE_ERRCODE_INVALIDFIRMWARE                     ((FOE_ERRORCODE)0x0000800d)
#define FOE_ERRCODE_NOFILE                              ((FOE_ERRORCODE)0x0000800f)
#define FOE_ERRCODE_UNKNOWNHEADER                       ((FOE_ERRORCODE)0x00008010)
#define FOE_ERRCODE_FLASPROBLEM                         ((FOE_ERRORCODE)0x00008011)
#define FOE_ERRCODE_INCOMPATIBLE                        ((FOE_ERRORCODE)0x00008012)
/* No actual FoE error code, used with esd stack only! (percDone: [0..100]) */
#define FOE_ERRCODE_BUSY(percDone)                      ((FOE_ERRORCODE)(0xe5de5d00 | (percDone & 0xff)))

#define EOE_HEADERLEN                                   (4)

typedef uint16_t EOE_RESULTCODE;
#define EOE_RESULTCODE_SUCCESS                          ((EOE_RESULTCODE)0x0000)
#define EOE_RESULTCODE_UNSPECIFIEDERR                   ((EOE_RESULTCODE)0x0001)
#define EOE_RESULTCODE_UNSUPPORTEDFRAME                 ((EOE_RESULTCODE)0x0002)
#define EOE_RESULTCODE_NOIPSUPPORT                      ((EOE_RESULTCODE)0x0201)
#define EOE_RESULTCODE_NOFILTERSUPPORT                  ((EOE_RESULTCODE)0x0401)

#define EOE_FRAMETYPE_FRAGMENTREQUEST                   (0)
#define EOE_FRAMETYPE_INITREQUEST                       (2)
#define EOE_FRAMETYPE_INITRESPONSE                      (3)
#define EOE_FRAMETYPE_SETIPPARAMREQUEST                 (2)
#define EOE_FRAMETYPE_SETIPPARAMRRESPONSE               (3)
#define EOE_FRAMETYPE_SETADDRFILTERREQUEST              (4)
#define EOE_FRAMETYPE_SETADDRFILTERRESPONSE             (5)
#define EOE_FRAMETYPE_GETIPPARAMREQUEST                 (6)
#define EOE_FRAMETYPE_GETIPPARAMRESPONSE                (7)
#define EOE_FRAMETYPE_GETADDRFILTERREQUEST              (8)
#define EOE_FRAMETYPE_GETADDRFILTERRESPONSE             (9)

#define EOE_HDR_GET_FRAMETYPE(mbxPkt)                   ((mbxPkt)->data[0] & 0x0f)
#define EOE_HDR_GET_PORT(mbxPkt)                        (((mbxPkt)->data[0] & 0xf0) >> 4)
#define EOE_HDR_GET_LASTFRAGMENT(mbxPkt)                ((mbxPkt)->data[1] & 0x01)
#define EOE_HDR_GET_TIMEAPPENDED(mbxPkt)                (((mbxPkt)->data[1] & 0x02) >> 1)
#define EOE_HDR_GET_TIMEREQUEST(mbxPkt)                 (((mbxPkt)->data[1] & 0x04) >> 2)
#define EOE_HDR_GET_FRAGMENTNUMBER(mbxPkt)              ((mbxPkt)->data[2] & 0x3f)
#define EOE_HDR_GET_COMPLETESIZE(mbxPkt)                ((((mbxPkt)->data[2] & 0xc0) >> 6) | (((mbxPkt)->data[3] & 0x0f) << 2))
#define EOE_HDR_GET_OFFSET(mbxPkt)                      EOE_HDR_GET_COMPLETESIZE(mbxPkt)
#define EOE_HDR_GET_FRAMENUMBER(mbxPkt)                 (((mbxPkt)->data[3] & 0xf0) >> 4)
#define EOE_HDR_GET_TIMESTAMP(mbxPkt)                   (MAKE_DWORD((mbxPkt)->data[(mbxPkt)->length - 4], (mbxPkt)->data[(mbxPkt)->length - 3], (mbxPkt)->data[(mbxPkt)->length - 2], (mbxPkt)->data[(mbxPkt)->length - 1]))
#define EOE_HDR_GET_IPPARAM_MACINCLUDED(mbxPkt)         ((mbxPkt)->data[4] & 0x01)
#define EOE_HDR_GET_IPPARAM_IPADDRINCLUDED(mbxPkt)      (((mbxPkt)->data[4] & 0x02) >> 1)
#define EOE_HDR_GET_IPPARAM_SUBNMASKINCLUDED(mbxPkt)    (((mbxPkt)->data[4] & 0x04) >> 2)
#define EOE_HDR_GET_IPPARAM_DEFGWINCLUDED(mbxPkt)       (((mbxPkt)->data[4] & 0x08) >> 3)
#define EOE_HDR_GET_IPPARAM_DNSSERVERINCLUDED(mbxPkt)   (((mbxPkt)->data[4] & 0x10) >> 4)
#define EOE_HDR_GET_IPPARAM_DNSNAMEINCLUDED(mbxPkt)     (((mbxPkt)->data[4] & 0x20) >> 5)
#define EOE_HDR_GET_SETFILTER_MACFILTERCNT(mbxPkt)      ((mbxPkt)->data[4] & 0x0f)
#define EOE_HDR_GET_SETFILTER_MACFILTERMASKCNT(mbxPkt)  (((mbxPkt)->data[4] & 0x30) >> 4)
#define EOE_HDR_GET_SETFILTER_INHIBITBROADCAST(mbxPkt)  (((mbxPkt)->data[4] & 0x80) >> 7)

#define MBX_VOE_HEADERLEN                               (6)
#define MBX_VOE_GET_VENDID(mbxPkt)                      MAKE_DWORD((mbxPkt)->data[0], (mbxPkt)->data[1], (mbxPkt)->data[2], (mbxPkt)->data[3])
#define MBX_VOE_GET_PROTID(mbxPkt)                      MAKE_WORD((mbxPkt)->data[4], (mbxPkt)->data[5])
#define MBX_VOE_GET_DATALEN(mbxPkt)                     ((mbxPkt)->length - MBX_VOE_HEADERLEN)

#define MBX_SOE_HEADERLEN                               (4)
#define MBX_SOE_GET_DATALEN(mbxPkt)                     ((mbxPkt)->length - MBX_SOE_HEADERLEN)
#define MBX_SOE_GET_OPCODE(mbxPkt)                      ((mbxPkt)->data[0] & 0x07)
#define MBX_SOE_GET_MOREFOLLOWSBIT(mbxPkt)              (((mbxPkt)->data[0] & 0x08) != 0)
#define MBX_SOE_GET_ERRORBIT(mbxPkt)                    (((mbxPkt)->data[0] & 0x10) != 0)
#define MBX_SOE_GET_DRIVENO(mbxPkt)                     ((mbxPkt)->data[0] >> 5)
/* Bit0: DataState, Bit1: Name, Bit2: Attribute, Bit3: Unit, Bit4: Min, Bit5: Max, Bit6: Value, Bit7: Reserved */
#define MBX_SOE_GET_ELEMENTS(mbxPkt)                    ((mbxPkt)->data[1])
#define MBX_SOE_GET_IDN(mbxPkt)                         MAKE_WORD((mbxPkt)->data[2], (mbxPkt)->data[3])
#define MBX_SOE_GET_FRAGSLEFT(mbxPkt)                   MBX_SOE_GET_IDN(mbxPkt)
#define MBX_SOE_SET_FRAGSLEFT(mbxPkt, u16)              do { (mbxPkt)->data[2] = LO_BYTE(u16); (mbxPkt)->data[3] = HI_BYTE(u16); } while (0)
#define MBX_SOE_OPCODE_RRQ                              (1)
#define MBX_SOE_OPCODE_RRS                              (2)
#define MBX_SOE_OPCODE_WRQ                              (3)
#define MBX_SOE_OPCODE_WRS                              (4)

#define SOE_DATATYPE_BINARY                             (0)
#define SOE_DATATYPE_UNSIGNED                           (1)
#define SOE_DATATYPE_SIGNED                             (2)
#define SOE_DATATYPE_HEX                                (3)
#define SOE_DATATYPE_UTF8                               (4)
#define SOE_DATATYPE_IDN                                (5)
#define SOE_DATATYPE_FLOAT                              (6)
#define SOE_DATATYPE_SERCOSTIME                         (7)

#define SOE_LENGTHTYPE_2BYTE                            (1)
#define SOE_LENGTHTYPE_4BYTE                            (2)
#define SOE_LENGTHTYPE_8BYTE                            (3)
#define SOE_LENGTHTYPE_1BYTEARRAY                       (4)
#define SOE_LENGTHTYPE_2BYTEARRAY                       (5)
#define SOE_LENGTHTYPE_4BYTEARRAY                       (6)
#define SOE_LENGTHTYPE_8BYTEARRAY                       (7)

#define SOE_LENGTHTYPE_ISVARIABLE(lt)                   (((lt) == SOE_LENGTHTYPE_1BYTEARRAY) || ((lt) == SOE_LENGTHTYPE_2BYTEARRAY) || ((lt) == SOE_LENGTHTYPE_4BYTEARRAY) || ((lt) == SOE_LENGTHTYPE_8BYTEARRAY))
#define SOE_LENGTHTYPE_GETFIXEDITEMSLEN(lt)             (((lt) == SOE_LENGTHTYPE_2BYTE) ? 2 : ((lt) == SOE_LENGTHTYPE_4BYTE) ? 4 : ((lt) == SOE_LENGTHTYPE_8BYTE) ? 8 : -1)
#define SOE_LENGTHTYPE_GETVARLENITEMSLEN(lt)            (((lt) == SOE_LENGTHTYPE_1BYTEARRAY) ? 1 : ((lt) == SOE_LENGTHTYPE_2BYTEARRAY) ? 2 : ((lt) == SOE_LENGTHTYPE_4BYTEARRAY) ? 4 : ((lt) == SOE_LENGTHTYPE_8BYTEARRAY) ? 8 : -1)
#define SOE_LENGTHTYPE_GETFIXEDORVARLENITEMSLEN(lt)     ((((lt) == SOE_LENGTHTYPE_8BYTE) || ((lt) == SOE_LENGTHTYPE_8BYTEARRAY)) ? 8 : (((lt) == SOE_LENGTHTYPE_4BYTE) || ((lt) == SOE_LENGTHTYPE_4BYTEARRAY)) ? 4 : (((lt) == SOE_LENGTHTYPE_2BYTE) || ((lt) == SOE_LENGTHTYPE_2BYTEARRAY)) ? 2 : ((lt) == SOE_LENGTHTYPE_1BYTEARRAY) ? 1 : -1)

#define SOE_ATTRIBUTE_DATASTATE                         (1 << 0)
#define SOE_ATTRIBUTE_NAME                              (1 << 1)
#define SOE_ATTRIBUTE_ATTRIBUTES                        (1 << 2)
#define SOE_ATTRIBUTE_UNIT                              (1 << 3)
#define SOE_ATTRIBUTE_MIN                               (1 << 4)
#define SOE_ATTRIBUTE_MAX                               (1 << 5)
#define SOE_ATTRIBUTE_VALUE                             (1 << 6)
#define SOE_ATTRIBUTE_RESERVED                          (1 << 7)
#define SOE_ATTRIBUTE_TO_STRING(a)                      (((a) == SOE_ATTRIBUTE_DATASTATE) ? "DATASTATE" : ((a) == SOE_ATTRIBUTE_NAME) ? "NAME" : ((a) == SOE_ATTRIBUTE_ATTRIBUTES) ? "ATTRIBUTES" : ((a) == SOE_ATTRIBUTE_UNIT) ? "UNIT" : ((a) == SOE_ATTRIBUTE_MIN) ? "MIN" : ((a) == SOE_ATTRIBUTE_MAX) ? "MAX" : ((a) == SOE_ATTRIBUTE_VALUE) ? "VALUE" : ((a) == SOE_ATTRIBUTE_RESERVED) ? "RESERVED" : "[Unknown]")

#define SOE_ATTRIBS_MAKE(dt, lt, dp, wpBits, isP, cf)   (((uint32_t)((wpBits) & 0x7) << 28) | ((uint32_t)((dp) & 0xf) << 24) | ((uint32_t)((dt) & 0x7) << 20) | ((uint32_t)((isP) != 0) << 19) | ((uint32_t)((lt) & 7) << 16) | ((cf) & 0xffff))
#define SOE_ATTRIBS_MAKE_NOPROC(dt, lt, dp, wpBits, cf) SOE_ATTRIBS_MAKE(dt, lt, dp, wpBits, 0, cf)
#define SOE_ATTRIBS_MAKE_PROC(wpBits)                   SOE_ATTRIBS_MAKE(SOE_DATATYPE_BINARY, SOE_LENGTHTYPE_2BYTE, 0, wpBits, 1, 1)
#define SOE_ATTRIBS_MAKE_I16(wpBits)                    SOE_ATTRIBS_MAKE(SOE_DATATYPE_SIGNED, SOE_LENGTHTYPE_2BYTE, 0, wpBits, 0, 1)
#define SOE_ATTRIBS_MAKE_I32(wpBits)                    SOE_ATTRIBS_MAKE(SOE_DATATYPE_SIGNED, SOE_LENGTHTYPE_4BYTE, 0, wpBits, 0, 1)
#define SOE_ATTRIBS_MAKE_U16(wpBits)                    SOE_ATTRIBS_MAKE(SOE_DATATYPE_UNSIGNED, SOE_LENGTHTYPE_2BYTE, 0, wpBits, 0, 1)
#define SOE_ATTRIBS_MAKE_U32(wpBits)                    SOE_ATTRIBS_MAKE(SOE_DATATYPE_UNSIGNED, SOE_LENGTHTYPE_4BYTE, 0, wpBits, 0, 1)
#define SOE_ATTRIBS_MAKE_U16HEX(wpBits)                 SOE_ATTRIBS_MAKE(SOE_DATATYPE_HEX, SOE_LENGTHTYPE_2BYTE, 0, wpBits, 0, 1)
#define SOE_ATTRIBS_MAKE_U32HEX(wpBits)                 SOE_ATTRIBS_MAKE(SOE_DATATYPE_HEX, SOE_LENGTHTYPE_4BYTE, 0, wpBits, 0, 1)

#define SOE_DECPOINTS_0                                 0
#define SOE_DECPOINTS_1                                 1
#define SOE_DECPOINTS_2                                 2
#define SOE_DECPOINTS_3                                 3
#define SOE_DECPOINTS_4                                 4
#define SOE_DECPOINTS_5                                 5
#define SOE_DECPOINTS_6                                 6
#define SOE_DECPOINTS_7                                 7
#define SOE_DECPOINTS_8                                 8
#define SOE_DECPOINTS_9                                 9
#define SOE_DECPOINTS_10                                10
#define SOE_DECPOINTS_11                                11
#define SOE_DECPOINTS_12                                12
#define SOE_DECPOINTS_13                                13
#define SOE_DECPOINTS_14                                14
#define SOE_DECPOINTS_15                                15

/* Bits 28..30 in attributes: */
#define SOE_WRITEPROT_NONE                              0
/* PreOp */
#define SOE_WRITEPROT_CP2                               1
/* SafeOp */
#define SOE_WRITEPROT_CP3                               2
/* Op */
#define SOE_WRITEPROT_CP4                               4
#define SOE_WRITEPROT_CP3CP4                            (SOE_WRITEPROT_CP3 | SOE_WRITEPROT_CP4)
#define SOE_WRITEPROT_CP2CP3CP4                         (SOE_WRITEPROT_CP2 | SOE_WRITEPROT_CP3 | SOE_WRITEPROT_CP4)

#define SOE_PROCEDURE_DATAINVALID                       (1 << 8)
#define SOE_PROCEDURE_STATEMASK                         0x000f
#define SOE_PROCEDURE_STATE_RESET                       0
#define SOE_PROCEDURE_STATE_INTERRUPTED                 1
#define SOE_PROCEDURE_STATE_EXECUTED                    3
#define SOE_PROCEDURE_STATE_PROCESSING                  7
#define SOE_PROCEDURE_STATE_FAILED                      15
#define SOE_PROCEDURE_CMD_RESET                         SOE_PROCEDURE_STATE_RESET
#define SOE_PROCEDURE_CMD_EXECUTE                       SOE_PROCEDURE_STATE_EXECUTED

typedef uint16_t SoE_Err;
/* Element independent */
#define SOE_ERR_NO_ERR                                  0x0000  /* No error */
#define SOE_ERR_GRIP_ELEM0                              0x0009  /* Invalid access to element 0 */
/* Element IDN */
#define SOE_ERR_ID_NOT_THERE                            0x1001  /* IDN not available */
#define SOE_ERR_GRIP_ELEM1                              0x1009  /* Invalid access to element 1 */
/* Element Name */
#define SOE_ERR_NO_NAME                                 0x2001  /* Name not available */
#define SOE_ERR_NAME_TOO_SHORT                          0x2002  /* Name transmission too short */
#define SOE_ERR_NAME_TOO_LONG                           0x2003  /* Name transmission too long */
#define SOE_ERR_WRITE_NAME                              0x2004  /* Name is read only */
#define SOE_ERR_JUST_NO_NAME                            0x2005  /* Name is temporarily read only */
/* Element Attribute */
#define SOE_ERR_ATTR_TOO_SHORT                          0x3002   /* Attribute transmission too short */
#define SOE_ERR_ATTR_TOO_LONG                           0x3003   /* Attribute transmission too long */
#define SOE_ERR_WRITE_ATTR                              0x3004   /* Attribute is read only */
#define SOE_ERR_JUST_NO_ATTR                            0x3005   /* Attribute is temporarily read only */
/* Element Unit */
#define SOE_ERR_NO_UNIT                                 0x4001   /* Unit not available */
#define SOE_ERR_UNIT_TOO_SHORT                          0x4002   /* Unit transmission too short */
#define SOE_ERR_UNIT_TOO_LONG                           0x4003   /* Unit transmission too long */
#define SOE_ERR_WRITE_UNIT                              0x4004   /* Unit is read only */
#define SOE_ERR_JUST_NO_UNIT                            0x4005   /* Unit is temporarily read only */
/* Element Minimum input value */
#define SOE_ERR_NO_MIN                                  0x5001   /* Minimum not available */
#define SOE_ERR_MIN_TOO_SHORT                           0x5002   /* Minimum transmission too short */
#define SOE_ERR_MIN_TOO_LONG                            0x5003   /* Minimum transmission too long */
#define SOE_ERR_WRITE_MIN                               0x5004   /* Minimum is read only only */
#define SOE_ERR_JUST_NO_MIN                             0x5005   /* Minimum is temporarily read only */
/* Element Maximum input value */
#define SOE_ERR_NO_MAX                                  0x5001   /* Maximum not available */
#define SOE_ERR_MAX_TOO_SHORT                           0x5002   /* Maximum transmission too short */
#define SOE_ERR_MAX_TOO_LONG                            0x5003   /* Maximum transmission too long */
#define SOE_ERR_WRITE_MAX                               0x5004   /* Maximum read only */
#define SOE_ERR_JUST_NO_MAX                             0x5005   /* Maximum temporarily read only */
/* Element Operation Data */
#define SOE_ERR_NO_DATA                                 0x7001   /* Data not available */
#define SOE_ERR_DATA_TOO_SHORT                          0x7002   /* Data transmission too short */
#define SOE_ERR_DATA_TOO_LONG                           0x7003   /* Data transmission too long */
#define SOE_ERR_WRITE_DATA                              0x7004   /* Data is read only */
#define SOE_ERR_JUST_NO_DATA                            0x7005   /* Data is temporarily read only */
#define SOE_ERR_DATA_TOO_SMALL                          0x7006   /* Data is smaller than minimum */
#define SOE_ERR_DATA_TOO_LARGE                          0x7007   /* Data is greater than maximum */
#define SOE_ERR_DATA_NOT_CORRECT                        0x7008   /* Data is invalid */
#define SOE_ERR_WRITE_DATA_PASS                         0x7009   /* Data is password protected */
#define SOE_ERR_NO_WRITE_DATA_NOW                       0x700A   /* Data is configured into process image and therefore read only   */
#define SOE_ERR_INVALID_INDIRECT                        0x700B   /* Invalid indirect addressing */
#define SOE_ERR_PROTECTED_BY_OTHERS                     0x700C   /* Data is write protected due to other settings */
#define SOE_ERR_INVALID_FLOAT                           0x700D   /* Invalid floating point number */
#define SOE_ERR_NO_WRITE_DATA_PL                        0x700E   /* Operation data is write protected at parameterization level */
#define SOE_ERR_NO_WRITE_DATA_OL                        0x700F   /* Operation data is write protected at operating level */
/* Procedure */
#define SOE_ERR_COM_ACTIVE_NOW                          0x7010   /* Procedure already active */
#define SOE_ERR_COM_CANT_BREAK                          0x7011   /* Procedure not interruptible */
#define SOE_ERR_COM_CANT_ACTIVE_NOW                     0x7012   /* Procedure temporarily not executable */
#define SOE_ERR_COM_PARA_FALSE                          0x7013   /* Procedure command invalid parameter */

#define MBX_AOE_HEADERLEN                               (32)
#define MBX_AOE_GET_DATALEN(mbxPkt)                     ((mbxPkt)->length - MBX_AOE_HEADERLEN)
/* No more AoE defines yet */

#endif /* ECATDEFS_INCLUDED */
